#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

void ATL_dJIK56x56x56NN0x0x0_a1_bX
   (const int M, const int N, const int K, const double alpha, const double * ATL_RESTRICT A, const int lda, const double * ATL_RESTRICT B, const int ldb, const double beta, double * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=N, TB=N, MB=56, NB=56, KB=56, 
 * lda=0, ldb=0, ldc=0, mu=4, nu=4, ku=56, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.8.3)
 */
{
   const double *stM = A + 56;
   const double *stN = B + (56*(ldb));
   const double *pfA = A + lda*M;
   const int incAk = (lda);
   const int incAm = 4 - (56*(lda)), incAn = -56;
   #define incBk 56
   const int incBm = -56, incBn = (((ldb) << 2));
   #define incAk0 incAk
   const int incBk0 = ((incBk) / 56);
   #define incCm 4
   const int incCn = (((ldc) << 2)) - 56;
   double *pC0=C, *pC1=pC0+(ldc), *pC2=pC1+(ldc), *pC3=pC2+(ldc);
   const double *pA0=A;
   const double *pB0=B, *pB1=pB0+(ldb), *pB2=pB1+(ldb), *pB3=pB2+(ldb);
   register int k;
   register double rA0, rA1, rA2, rA3;
   register double rB0, rB1, rB2, rB3;
   register double m0, m1, m2, m3, m4, m5, m6, m7;
   register double rC0_0, rC1_0, rC2_0, rC3_0, rC0_1, rC1_1, rC2_1, rC3_1, rC0_2, rC1_2, rC2_2, rC3_2, rC0_3, rC1_3, rC2_3, rC3_3;
   do /* N-loop */
   {
      ATL_pfl1R(pfA+0);
      ATL_pfl1R(pfA+8);
      ATL_pfl1R(pfA+16);
      ATL_pfl1R(pfA+24);
      ATL_pfl1R(pfA+32);
      ATL_pfl1R(pfA+40);
      ATL_pfl1R(pfA+48);
      pfA += lda;
      do /* M-loop */
      {
         rA0 = beta;
         rC0_0 = *pC0;
         rC0_0 *= rA0;
         rC1_0 = pC0[1];
         rC1_0 *= rA0;
         rC2_0 = pC0[2];
         rC2_0 *= rA0;
         rC3_0 = pC0[3];
         rC3_0 *= rA0;
         rC0_1 = *pC1;
         rC0_1 *= rA0;
         rC1_1 = pC1[1];
         rC1_1 *= rA0;
         rC2_1 = pC1[2];
         rC2_1 *= rA0;
         rC3_1 = pC1[3];
         rC3_1 *= rA0;
         rC0_2 = *pC2;
         rC0_2 *= rA0;
         rC1_2 = pC2[1];
         rC1_2 *= rA0;
         rC2_2 = pC2[2];
         rC2_2 *= rA0;
         rC3_2 = pC2[3];
         rC3_2 *= rA0;
         rC0_3 = *pC3;
         rC0_3 *= rA0;
         rC1_3 = pC3[1];
         rC1_3 *= rA0;
         rC2_3 = pC3[2];
         rC2_3 *= rA0;
         rC3_3 = pC3[3];
         rC3_3 *= rA0;
/*
 *       Start pipeline
 */
         rA0 = *pA0;
         rB0 = *pB0;
         rA1 = pA0[1];
         rA2 = pA0[2];
         rA3 = pA0[3];
         rB1 = *pB1;
         rB2 = *pB2;
         m0 = rA0 * rB0;
         rB3 = *pB3;
         m1 = rA1 * rB0;
         m2 = rA2 * rB0;
         m3 = rA3 * rB0;
         m4 = rA0 * rB1;
         m5 = rA1 * rB1;
         m6 = rA2 * rB1;
         m7 = rA3 * rB1;

/*
 *       Completely unrolled K-loop
 */
         rC0_0 += m0;
         m0 = rA0 * rB2;
         rC1_0 += m1;
         m1 = rA1 * rB2;
         rC2_0 += m2;
         m2 = rA2 * rB2;
         rC3_0 += m3;
         m3 = rA3 * rB2;
         rC0_1 += m4;
         m4 = rA0 * rB3;
         rC1_1 += m5;
         m5 = rA1 * rB3;
         rC2_1 += m6;
         m6 = rA2 * rB3;
         rC3_1 += m7;
         m7 = rA3 * rB3;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[1];
         rA1 = pA0[1];
         rA2 = pA0[2];
         rA3 = pA0[3];
         rB1 = pB1[1];
         rB2 = pB2[1];
         rB3 = pB3[1];
         rC0_2 += m0;
         m0 = rA0 * rB0;
         rC1_2 += m1;
         m1 = rA1 * rB0;
         rC2_2 += m2;
         m2 = rA2 * rB0;
         rC3_2 += m3;
         m3 = rA3 * rB0;
         rC0_3 += m4;
         m4 = rA0 * rB1;
         rC1_3 += m5;
         m5 = rA1 * rB1;
         rC2_3 += m6;
         m6 = rA2 * rB1;
         rC3_3 += m7;
         m7 = rA3 * rB1;
         rC0_0 += m0;
         m0 = rA0 * rB2;
         rC1_0 += m1;
         m1 = rA1 * rB2;
         rC2_0 += m2;
         m2 = rA2 * rB2;
         rC3_0 += m3;
         m3 = rA3 * rB2;
         rC0_1 += m4;
         m4 = rA0 * rB3;
         rC1_1 += m5;
         m5 = rA1 * rB3;
         rC2_1 += m6;
         m6 = rA2 * rB3;
         rC3_1 += m7;
         m7 = rA3 * rB3;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[2];
         rA1 = pA0[1];
         rA2 = pA0[2];
         rA3 = pA0[3];
         rB1 = pB1[2];
         rB2 = pB2[2];
         rB3 = pB3[2];
         rC0_2 += m0;
         m0 = rA0 * rB0;
         rC1_2 += m1;
         m1 = rA1 * rB0;
         rC2_2 += m2;
         m2 = rA2 * rB0;
         rC3_2 += m3;
         m3 = rA3 * rB0;
         rC0_3 += m4;
         m4 = rA0 * rB1;
         rC1_3 += m5;
         m5 = rA1 * rB1;
         rC2_3 += m6;
         m6 = rA2 * rB1;
         rC3_3 += m7;
         m7 = rA3 * rB1;
         rC0_0 += m0;
         m0 = rA0 * rB2;
         rC1_0 += m1;
         m1 = rA1 * rB2;
         rC2_0 += m2;
         m2 = rA2 * rB2;
         rC3_0 += m3;
         m3 = rA3 * rB2;
         rC0_1 += m4;
         m4 = rA0 * rB3;
         rC1_1 += m5;
         m5 = rA1 * rB3;
         rC2_1 += m6;
         m6 = rA2 * rB3;
         rC3_1 += m7;
         m7 = rA3 * rB3;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[3];
         rA1 = pA0[1];
         rA2 = pA0[2];
         rA3 = pA0[3];
         rB1 = pB1[3];
         rB2 = pB2[3];
         rB3 = pB3[3];
         rC0_2 += m0;
         m0 = rA0 * rB0;
         rC1_2 += m1;
         m1 = rA1 * rB0;
         rC2_2 += m2;
         m2 = rA2 * rB0;
         rC3_2 += m3;
         m3 = rA3 * rB0;
         rC0_3 += m4;
         m4 = rA0 * rB1;
         rC1_3 += m5;
         m5 = rA1 * rB1;
         rC2_3 += m6;
         m6 = rA2 * rB1;
         rC3_3 += m7;
         m7 = rA3 * rB1;
         rC0_0 += m0;
         m0 = rA0 * rB2;
         rC1_0 += m1;
         m1 = rA1 * rB2;
         rC2_0 += m2;
         m2 = rA2 * rB2;
         rC3_0 += m3;
         m3 = rA3 * rB2;
         rC0_1 += m4;
         m4 = rA0 * rB3;
         rC1_1 += m5;
         m5 = rA1 * rB3;
         rC2_1 += m6;
         m6 = rA2 * rB3;
         rC3_1 += m7;
         m7 = rA3 * rB3;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[4];
         rA1 = pA0[1];
         rA2 = pA0[2];
         rA3 = pA0[3];
         rB1 = pB1[4];
         rB2 = pB2[4];
         rB3 = pB3[4];
         rC0_2 += m0;
         m0 = rA0 * rB0;
         rC1_2 += m1;
         m1 = rA1 * rB0;
         rC2_2 += m2;
         m2 = rA2 * rB0;
         rC3_2 += m3;
         m3 = rA3 * rB0;
         rC0_3 += m4;
         m4 = rA0 * rB1;
         rC1_3 += m5;
         m5 = rA1 * rB1;
         rC2_3 += m6;
         m6 = rA2 * rB1;
         rC3_3 += m7;
         m7 = rA3 * rB1;
         rC0_0 += m0;
         m0 = rA0 * rB2;
         rC1_0 += m1;
         m1 = rA1 * rB2;
         rC2_0 += m2;
         m2 = rA2 * rB2;
         rC3_0 += m3;
         m3 = rA3 * rB2;
         rC0_1 += m4;
         m4 = rA0 * rB3;
         rC1_1 += m5;
         m5 = rA1 * rB3;
         rC2_1 += m6;
         m6 = rA2 * rB3;
         rC3_1 += m7;
         m7 = rA3 * rB3;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[5];
         rA1 = pA0[1];
         rA2 = pA0[2];
         rA3 = pA0[3];
         rB1 = pB1[5];
         rB2 = pB2[5];
         rB3 = pB3[5];
         rC0_2 += m0;
         m0 = rA0 * rB0;
         rC1_2 += m1;
         m1 = rA1 * rB0;
         rC2_2 += m2;
         m2 = rA2 * rB0;
         rC3_2 += m3;
         m3 = rA3 * rB0;
         rC0_3 += m4;
         m4 = rA0 * rB1;
         rC1_3 += m5;
         m5 = rA1 * rB1;
         rC2_3 += m6;
         m6 = rA2 * rB1;
         rC3_3 += m7;
         m7 = rA3 * rB1;
         rC0_0 += m0;
         m0 = rA0 * rB2;
         rC1_0 += m1;
         m1 = rA1 * rB2;
         rC2_0 += m2;
         m2 = rA2 * rB2;
         rC3_0 += m3;
         m3 = rA3 * rB2;
         rC0_1 += m4;
         m4 = rA0 * rB3;
         rC1_1 += m5;
         m5 = rA1 * rB3;
         rC2_1 += m6;
         m6 = rA2 * rB3;
         rC3_1 += m7;
         m7 = rA3 * rB3;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[6];
         rA1 = pA0[1];
         rA2 = pA0[2];
         rA3 = pA0[3];
         rB1 = pB1[6];
         rB2 = pB2[6];
         rB3 = pB3[6];
         rC0_2 += m0;
         m0 = rA0 * rB0;
         rC1_2 += m1;
         m1 = rA1 * rB0;
         rC2_2 += m2;
         m2 = rA2 * rB0;
         rC3_2 += m3;
         m3 = rA3 * rB0;
         rC0_3 += m4;
         m4 = rA0 * rB1;
         rC1_3 += m5;
         m5 = rA1 * rB1;
         rC2_3 += m6;
         m6 = rA2 * rB1;
         rC3_3 += m7;
         m7 = rA3 * rB1;
         rC0_0 += m0;
         m0 = rA0 * rB2;
         rC1_0 += m1;
         m1 = rA1 * rB2;
         rC2_0 += m2;
         m2 = rA2 * rB2;
         rC3_0 += m3;
         m3 = rA3 * rB2;
         rC0_1 += m4;
         m4 = rA0 * rB3;
         rC1_1 += m5;
         m5 = rA1 * rB3;
         rC2_1 += m6;
         m6 = rA2 * rB3;
         rC3_1 += m7;
         m7 = rA3 * rB3;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[7];
         rA1 = pA0[1];
         rA2 = pA0[2];
         rA3 = pA0[3];
         rB1 = pB1[7];
         rB2 = pB2[7];
         rB3 = pB3[7];
         rC0_2 += m0;
         m0 = rA0 * rB0;
         rC1_2 += m1;
         m1 = rA1 * rB0;
         rC2_2 += m2;
         m2 = rA2 * rB0;
         rC3_2 += m3;
         m3 = rA3 * rB0;
         rC0_3 += m4;
         m4 = rA0 * rB1;
         rC1_3 += m5;
         m5 = rA1 * rB1;
         rC2_3 += m6;
         m6 = rA2 * rB1;
         rC3_3 += m7;
         m7 = rA3 * rB1;
         rC0_0 += m0;
         m0 = rA0 * rB2;
         rC1_0 += m1;
         m1 = rA1 * rB2;
         rC2_0 += m2;
         m2 = rA2 * rB2;
         rC3_0 += m3;
         m3 = rA3 * rB2;
         rC0_1 += m4;
         m4 = rA0 * rB3;
         rC1_1 += m5;
         m5 = rA1 * rB3;
         rC2_1 += m6;
         m6 = rA2 * rB3;
         rC3_1 += m7;
         m7 = rA3 * rB3;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[8];
         rA1 = pA0[1];
         rA2 = pA0[2];
         rA3 = pA0[3];
         rB1 = pB1[8];
         rB2 = pB2[8];
         rB3 = pB3[8];
         rC0_2 += m0;
         m0 = rA0 * rB0;
         rC1_2 += m1;
         m1 = rA1 * rB0;
         rC2_2 += m2;
         m2 = rA2 * rB0;
         rC3_2 += m3;
         m3 = rA3 * rB0;
         rC0_3 += m4;
         m4 = rA0 * rB1;
         rC1_3 += m5;
         m5 = rA1 * rB1;
         rC2_3 += m6;
         m6 = rA2 * rB1;
         rC3_3 += m7;
         m7 = rA3 * rB1;
         rC0_0 += m0;
         m0 = rA0 * rB2;
         rC1_0 += m1;
         m1 = rA1 * rB2;
         rC2_0 += m2;
         m2 = rA2 * rB2;
         rC3_0 += m3;
         m3 = rA3 * rB2;
         rC0_1 += m4;
         m4 = rA0 * rB3;
         rC1_1 += m5;
         m5 = rA1 * rB3;
         rC2_1 += m6;
         m6 = rA2 * rB3;
         rC3_1 += m7;
         m7 = rA3 * rB3;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[9];
         rA1 = pA0[1];
         rA2 = pA0[2];
         rA3 = pA0[3];
         rB1 = pB1[9];
         rB2 = pB2[9];
         rB3 = pB3[9];
         rC0_2 += m0;
         m0 = rA0 * rB0;
         rC1_2 += m1;
         m1 = rA1 * rB0;
         rC2_2 += m2;
         m2 = rA2 * rB0;
         rC3_2 += m3;
         m3 = rA3 * rB0;
         rC0_3 += m4;
         m4 = rA0 * rB1;
         rC1_3 += m5;
         m5 = rA1 * rB1;
         rC2_3 += m6;
         m6 = rA2 * rB1;
         rC3_3 += m7;
         m7 = rA3 * rB1;
         rC0_0 += m0;
         m0 = rA0 * rB2;
         rC1_0 += m1;
         m1 = rA1 * rB2;
         rC2_0 += m2;
         m2 = rA2 * rB2;
         rC3_0 += m3;
         m3 = rA3 * rB2;
         rC0_1 += m4;
         m4 = rA0 * rB3;
         rC1_1 += m5;
         m5 = rA1 * rB3;
         rC2_1 += m6;
         m6 = rA2 * rB3;
         rC3_1 += m7;
         m7 = rA3 * rB3;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[10];
         rA1 = pA0[1];
         rA2 = pA0[2];
         rA3 = pA0[3];
         rB1 = pB1[10];
         rB2 = pB2[10];
         rB3 = pB3[10];
         rC0_2 += m0;
         m0 = rA0 * rB0;
         rC1_2 += m1;
         m1 = rA1 * rB0;
         rC2_2 += m2;
         m2 = rA2 * rB0;
         rC3_2 += m3;
         m3 = rA3 * rB0;
         rC0_3 += m4;
         m4 = rA0 * rB1;
         rC1_3 += m5;
         m5 = rA1 * rB1;
         rC2_3 += m6;
         m6 = rA2 * rB1;
         rC3_3 += m7;
         m7 = rA3 * rB1;
         rC0_0 += m0;
         m0 = rA0 * rB2;
         rC1_0 += m1;
         m1 = rA1 * rB2;
         rC2_0 += m2;
         m2 = rA2 * rB2;
         rC3_0 += m3;
         m3 = rA3 * rB2;
         rC0_1 += m4;
         m4 = rA0 * rB3;
         rC1_1 += m5;
         m5 = rA1 * rB3;
         rC2_1 += m6;
         m6 = rA2 * rB3;
         rC3_1 += m7;
         m7 = rA3 * rB3;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[11];
         rA1 = pA0[1];
         rA2 = pA0[2];
         rA3 = pA0[3];
         rB1 = pB1[11];
         rB2 = pB2[11];
         rB3 = pB3[11];
         rC0_2 += m0;
         m0 = rA0 * rB0;
         rC1_2 += m1;
         m1 = rA1 * rB0;
         rC2_2 += m2;
         m2 = rA2 * rB0;
         rC3_2 += m3;
         m3 = rA3 * rB0;
         rC0_3 += m4;
         m4 = rA0 * rB1;
         rC1_3 += m5;
         m5 = rA1 * rB1;
         rC2_3 += m6;
         m6 = rA2 * rB1;
         rC3_3 += m7;
         m7 = rA3 * rB1;
         rC0_0 += m0;
         m0 = rA0 * rB2;
         rC1_0 += m1;
         m1 = rA1 * rB2;
         rC2_0 += m2;
         m2 = rA2 * rB2;
         rC3_0 += m3;
         m3 = rA3 * rB2;
         rC0_1 += m4;
         m4 = rA0 * rB3;
         rC1_1 += m5;
         m5 = rA1 * rB3;
         rC2_1 += m6;
         m6 = rA2 * rB3;
         rC3_1 += m7;
         m7 = rA3 * rB3;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[12];
         rA1 = pA0[1];
         rA2 = pA0[2];
         rA3 = pA0[3];
         rB1 = pB1[12];
         rB2 = pB2[12];
         rB3 = pB3[12];
         rC0_2 += m0;
         m0 = rA0 * rB0;
         rC1_2 += m1;
         m1 = rA1 * rB0;
         rC2_2 += m2;
         m2 = rA2 * rB0;
         rC3_2 += m3;
         m3 = rA3 * rB0;
         rC0_3 += m4;
         m4 = rA0 * rB1;
         rC1_3 += m5;
         m5 = rA1 * rB1;
         rC2_3 += m6;
         m6 = rA2 * rB1;
         rC3_3 += m7;
         m7 = rA3 * rB1;
         rC0_0 += m0;
         m0 = rA0 * rB2;
         rC1_0 += m1;
         m1 = rA1 * rB2;
         rC2_0 += m2;
         m2 = rA2 * rB2;
         rC3_0 += m3;
         m3 = rA3 * rB2;
         rC0_1 += m4;
         m4 = rA0 * rB3;
         rC1_1 += m5;
         m5 = rA1 * rB3;
         rC2_1 += m6;
         m6 = rA2 * rB3;
         rC3_1 += m7;
         m7 = rA3 * rB3;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[13];
         rA1 = pA0[1];
         rA2 = pA0[2];
         rA3 = pA0[3];
         rB1 = pB1[13];
         rB2 = pB2[13];
         rB3 = pB3[13];
         rC0_2 += m0;
         m0 = rA0 * rB0;
         rC1_2 += m1;
         m1 = rA1 * rB0;
         rC2_2 += m2;
         m2 = rA2 * rB0;
         rC3_2 += m3;
         m3 = rA3 * rB0;
         rC0_3 += m4;
         m4 = rA0 * rB1;
         rC1_3 += m5;
         m5 = rA1 * rB1;
         rC2_3 += m6;
         m6 = rA2 * rB1;
         rC3_3 += m7;
         m7 = rA3 * rB1;
         rC0_0 += m0;
         m0 = rA0 * rB2;
         rC1_0 += m1;
         m1 = rA1 * rB2;
         rC2_0 += m2;
         m2 = rA2 * rB2;
         rC3_0 += m3;
         m3 = rA3 * rB2;
         rC0_1 += m4;
         m4 = rA0 * rB3;
         rC1_1 += m5;
         m5 = rA1 * rB3;
         rC2_1 += m6;
         m6 = rA2 * rB3;
         rC3_1 += m7;
         m7 = rA3 * rB3;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[14];
         rA1 = pA0[1];
         rA2 = pA0[2];
         rA3 = pA0[3];
         rB1 = pB1[14];
         rB2 = pB2[14];
         rB3 = pB3[14];
         rC0_2 += m0;
         m0 = rA0 * rB0;
         rC1_2 += m1;
         m1 = rA1 * rB0;
         rC2_2 += m2;
         m2 = rA2 * rB0;
         rC3_2 += m3;
         m3 = rA3 * rB0;
         rC0_3 += m4;
         m4 = rA0 * rB1;
         rC1_3 += m5;
         m5 = rA1 * rB1;
         rC2_3 += m6;
         m6 = rA2 * rB1;
         rC3_3 += m7;
         m7 = rA3 * rB1;
         rC0_0 += m0;
         m0 = rA0 * rB2;
         rC1_0 += m1;
         m1 = rA1 * rB2;
         rC2_0 += m2;
         m2 = rA2 * rB2;
         rC3_0 += m3;
         m3 = rA3 * rB2;
         rC0_1 += m4;
         m4 = rA0 * rB3;
         rC1_1 += m5;
         m5 = rA1 * rB3;
         rC2_1 += m6;
         m6 = rA2 * rB3;
         rC3_1 += m7;
         m7 = rA3 * rB3;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[15];
         rA1 = pA0[1];
         rA2 = pA0[2];
         rA3 = pA0[3];
         rB1 = pB1[15];
         rB2 = pB2[15];
         rB3 = pB3[15];
         rC0_2 += m0;
         m0 = rA0 * rB0;
         rC1_2 += m1;
         m1 = rA1 * rB0;
         rC2_2 += m2;
         m2 = rA2 * rB0;
         rC3_2 += m3;
         m3 = rA3 * rB0;
         rC0_3 += m4;
         m4 = rA0 * rB1;
         rC1_3 += m5;
         m5 = rA1 * rB1;
         rC2_3 += m6;
         m6 = rA2 * rB1;
         rC3_3 += m7;
         m7 = rA3 * rB1;
         rC0_0 += m0;
         m0 = rA0 * rB2;
         rC1_0 += m1;
         m1 = rA1 * rB2;
         rC2_0 += m2;
         m2 = rA2 * rB2;
         rC3_0 += m3;
         m3 = rA3 * rB2;
         rC0_1 += m4;
         m4 = rA0 * rB3;
         rC1_1 += m5;
         m5 = rA1 * rB3;
         rC2_1 += m6;
         m6 = rA2 * rB3;
         rC3_1 += m7;
         m7 = rA3 * rB3;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[16];
         rA1 = pA0[1];
         rA2 = pA0[2];
         rA3 = pA0[3];
         rB1 = pB1[16];
         rB2 = pB2[16];
         rB3 = pB3[16];
         rC0_2 += m0;
         m0 = rA0 * rB0;
         rC1_2 += m1;
         m1 = rA1 * rB0;
         rC2_2 += m2;
         m2 = rA2 * rB0;
         rC3_2 += m3;
         m3 = rA3 * rB0;
         rC0_3 += m4;
         m4 = rA0 * rB1;
         rC1_3 += m5;
         m5 = rA1 * rB1;
         rC2_3 += m6;
         m6 = rA2 * rB1;
         rC3_3 += m7;
         m7 = rA3 * rB1;
         rC0_0 += m0;
         m0 = rA0 * rB2;
         rC1_0 += m1;
         m1 = rA1 * rB2;
         rC2_0 += m2;
         m2 = rA2 * rB2;
         rC3_0 += m3;
         m3 = rA3 * rB2;
         rC0_1 += m4;
         m4 = rA0 * rB3;
         rC1_1 += m5;
         m5 = rA1 * rB3;
         rC2_1 += m6;
         m6 = rA2 * rB3;
         rC3_1 += m7;
         m7 = rA3 * rB3;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[17];
         rA1 = pA0[1];
         rA2 = pA0[2];
         rA3 = pA0[3];
         rB1 = pB1[17];
         rB2 = pB2[17];
         rB3 = pB3[17];
         rC0_2 += m0;
         m0 = rA0 * rB0;
         rC1_2 += m1;
         m1 = rA1 * rB0;
         rC2_2 += m2;
         m2 = rA2 * rB0;
         rC3_2 += m3;
         m3 = rA3 * rB0;
         rC0_3 += m4;
         m4 = rA0 * rB1;
         rC1_3 += m5;
         m5 = rA1 * rB1;
         rC2_3 += m6;
         m6 = rA2 * rB1;
         rC3_3 += m7;
         m7 = rA3 * rB1;
         rC0_0 += m0;
         m0 = rA0 * rB2;
         rC1_0 += m1;
         m1 = rA1 * rB2;
         rC2_0 += m2;
         m2 = rA2 * rB2;
         rC3_0 += m3;
         m3 = rA3 * rB2;
         rC0_1 += m4;
         m4 = rA0 * rB3;
         rC1_1 += m5;
         m5 = rA1 * rB3;
         rC2_1 += m6;
         m6 = rA2 * rB3;
         rC3_1 += m7;
         m7 = rA3 * rB3;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[18];
         rA1 = pA0[1];
         rA2 = pA0[2];
         rA3 = pA0[3];
         rB1 = pB1[18];
         rB2 = pB2[18];
         rB3 = pB3[18];
         rC0_2 += m0;
         m0 = rA0 * rB0;
         rC1_2 += m1;
         m1 = rA1 * rB0;
         rC2_2 += m2;
         m2 = rA2 * rB0;
         rC3_2 += m3;
         m3 = rA3 * rB0;
         rC0_3 += m4;
         m4 = rA0 * rB1;
         rC1_3 += m5;
         m5 = rA1 * rB1;
         rC2_3 += m6;
         m6 = rA2 * rB1;
         rC3_3 += m7;
         m7 = rA3 * rB1;
         rC0_0 += m0;
         m0 = rA0 * rB2;
         rC1_0 += m1;
         m1 = rA1 * rB2;
         rC2_0 += m2;
         m2 = rA2 * rB2;
         rC3_0 += m3;
         m3 = rA3 * rB2;
         rC0_1 += m4;
         m4 = rA0 * rB3;
         rC1_1 += m5;
         m5 = rA1 * rB3;
         rC2_1 += m6;
         m6 = rA2 * rB3;
         rC3_1 += m7;
         m7 = rA3 * rB3;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[19];
         rA1 = pA0[1];
         rA2 = pA0[2];
         rA3 = pA0[3];
         rB1 = pB1[19];
         rB2 = pB2[19];
         rB3 = pB3[19];
         rC0_2 += m0;
         m0 = rA0 * rB0;
         rC1_2 += m1;
         m1 = rA1 * rB0;
         rC2_2 += m2;
         m2 = rA2 * rB0;
         rC3_2 += m3;
         m3 = rA3 * rB0;
         rC0_3 += m4;
         m4 = rA0 * rB1;
         rC1_3 += m5;
         m5 = rA1 * rB1;
         rC2_3 += m6;
         m6 = rA2 * rB1;
         rC3_3 += m7;
         m7 = rA3 * rB1;
         rC0_0 += m0;
         m0 = rA0 * rB2;
         rC1_0 += m1;
         m1 = rA1 * rB2;
         rC2_0 += m2;
         m2 = rA2 * rB2;
         rC3_0 += m3;
         m3 = rA3 * rB2;
         rC0_1 += m4;
         m4 = rA0 * rB3;
         rC1_1 += m5;
         m5 = rA1 * rB3;
         rC2_1 += m6;
         m6 = rA2 * rB3;
         rC3_1 += m7;
         m7 = rA3 * rB3;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[20];
         rA1 = pA0[1];
         rA2 = pA0[2];
         rA3 = pA0[3];
         rB1 = pB1[20];
         rB2 = pB2[20];
         rB3 = pB3[20];
         rC0_2 += m0;
         m0 = rA0 * rB0;
         rC1_2 += m1;
         m1 = rA1 * rB0;
         rC2_2 += m2;
         m2 = rA2 * rB0;
         rC3_2 += m3;
         m3 = rA3 * rB0;
         rC0_3 += m4;
         m4 = rA0 * rB1;
         rC1_3 += m5;
         m5 = rA1 * rB1;
         rC2_3 += m6;
         m6 = rA2 * rB1;
         rC3_3 += m7;
         m7 = rA3 * rB1;
         rC0_0 += m0;
         m0 = rA0 * rB2;
         rC1_0 += m1;
         m1 = rA1 * rB2;
         rC2_0 += m2;
         m2 = rA2 * rB2;
         rC3_0 += m3;
         m3 = rA3 * rB2;
         rC0_1 += m4;
         m4 = rA0 * rB3;
         rC1_1 += m5;
         m5 = rA1 * rB3;
         rC2_1 += m6;
         m6 = rA2 * rB3;
         rC3_1 += m7;
         m7 = rA3 * rB3;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[21];
         rA1 = pA0[1];
         rA2 = pA0[2];
         rA3 = pA0[3];
         rB1 = pB1[21];
         rB2 = pB2[21];
         rB3 = pB3[21];
         rC0_2 += m0;
         m0 = rA0 * rB0;
         rC1_2 += m1;
         m1 = rA1 * rB0;
         rC2_2 += m2;
         m2 = rA2 * rB0;
         rC3_2 += m3;
         m3 = rA3 * rB0;
         rC0_3 += m4;
         m4 = rA0 * rB1;
         rC1_3 += m5;
         m5 = rA1 * rB1;
         rC2_3 += m6;
         m6 = rA2 * rB1;
         rC3_3 += m7;
         m7 = rA3 * rB1;
         rC0_0 += m0;
         m0 = rA0 * rB2;
         rC1_0 += m1;
         m1 = rA1 * rB2;
         rC2_0 += m2;
         m2 = rA2 * rB2;
         rC3_0 += m3;
         m3 = rA3 * rB2;
         rC0_1 += m4;
         m4 = rA0 * rB3;
         rC1_1 += m5;
         m5 = rA1 * rB3;
         rC2_1 += m6;
         m6 = rA2 * rB3;
         rC3_1 += m7;
         m7 = rA3 * rB3;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[22];
         rA1 = pA0[1];
         rA2 = pA0[2];
         rA3 = pA0[3];
         rB1 = pB1[22];
         rB2 = pB2[22];
         rB3 = pB3[22];
         rC0_2 += m0;
         m0 = rA0 * rB0;
         rC1_2 += m1;
         m1 = rA1 * rB0;
         rC2_2 += m2;
         m2 = rA2 * rB0;
         rC3_2 += m3;
         m3 = rA3 * rB0;
         rC0_3 += m4;
         m4 = rA0 * rB1;
         rC1_3 += m5;
         m5 = rA1 * rB1;
         rC2_3 += m6;
         m6 = rA2 * rB1;
         rC3_3 += m7;
         m7 = rA3 * rB1;
         rC0_0 += m0;
         m0 = rA0 * rB2;
         rC1_0 += m1;
         m1 = rA1 * rB2;
         rC2_0 += m2;
         m2 = rA2 * rB2;
         rC3_0 += m3;
         m3 = rA3 * rB2;
         rC0_1 += m4;
         m4 = rA0 * rB3;
         rC1_1 += m5;
         m5 = rA1 * rB3;
         rC2_1 += m6;
         m6 = rA2 * rB3;
         rC3_1 += m7;
         m7 = rA3 * rB3;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[23];
         rA1 = pA0[1];
         rA2 = pA0[2];
         rA3 = pA0[3];
         rB1 = pB1[23];
         rB2 = pB2[23];
         rB3 = pB3[23];
         rC0_2 += m0;
         m0 = rA0 * rB0;
         rC1_2 += m1;
         m1 = rA1 * rB0;
         rC2_2 += m2;
         m2 = rA2 * rB0;
         rC3_2 += m3;
         m3 = rA3 * rB0;
         rC0_3 += m4;
         m4 = rA0 * rB1;
         rC1_3 += m5;
         m5 = rA1 * rB1;
         rC2_3 += m6;
         m6 = rA2 * rB1;
         rC3_3 += m7;
         m7 = rA3 * rB1;
         rC0_0 += m0;
         m0 = rA0 * rB2;
         rC1_0 += m1;
         m1 = rA1 * rB2;
         rC2_0 += m2;
         m2 = rA2 * rB2;
         rC3_0 += m3;
         m3 = rA3 * rB2;
         rC0_1 += m4;
         m4 = rA0 * rB3;
         rC1_1 += m5;
         m5 = rA1 * rB3;
         rC2_1 += m6;
         m6 = rA2 * rB3;
         rC3_1 += m7;
         m7 = rA3 * rB3;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[24];
         rA1 = pA0[1];
         rA2 = pA0[2];
         rA3 = pA0[3];
         rB1 = pB1[24];
         rB2 = pB2[24];
         rB3 = pB3[24];
         rC0_2 += m0;
         m0 = rA0 * rB0;
         rC1_2 += m1;
         m1 = rA1 * rB0;
         rC2_2 += m2;
         m2 = rA2 * rB0;
         rC3_2 += m3;
         m3 = rA3 * rB0;
         rC0_3 += m4;
         m4 = rA0 * rB1;
         rC1_3 += m5;
         m5 = rA1 * rB1;
         rC2_3 += m6;
         m6 = rA2 * rB1;
         rC3_3 += m7;
         m7 = rA3 * rB1;
         rC0_0 += m0;
         m0 = rA0 * rB2;
         rC1_0 += m1;
         m1 = rA1 * rB2;
         rC2_0 += m2;
         m2 = rA2 * rB2;
         rC3_0 += m3;
         m3 = rA3 * rB2;
         rC0_1 += m4;
         m4 = rA0 * rB3;
         rC1_1 += m5;
         m5 = rA1 * rB3;
         rC2_1 += m6;
         m6 = rA2 * rB3;
         rC3_1 += m7;
         m7 = rA3 * rB3;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[25];
         rA1 = pA0[1];
         rA2 = pA0[2];
         rA3 = pA0[3];
         rB1 = pB1[25];
         rB2 = pB2[25];
         rB3 = pB3[25];
         rC0_2 += m0;
         m0 = rA0 * rB0;
         rC1_2 += m1;
         m1 = rA1 * rB0;
         rC2_2 += m2;
         m2 = rA2 * rB0;
         rC3_2 += m3;
         m3 = rA3 * rB0;
         rC0_3 += m4;
         m4 = rA0 * rB1;
         rC1_3 += m5;
         m5 = rA1 * rB1;
         rC2_3 += m6;
         m6 = rA2 * rB1;
         rC3_3 += m7;
         m7 = rA3 * rB1;
         rC0_0 += m0;
         m0 = rA0 * rB2;
         rC1_0 += m1;
         m1 = rA1 * rB2;
         rC2_0 += m2;
         m2 = rA2 * rB2;
         rC3_0 += m3;
         m3 = rA3 * rB2;
         rC0_1 += m4;
         m4 = rA0 * rB3;
         rC1_1 += m5;
         m5 = rA1 * rB3;
         rC2_1 += m6;
         m6 = rA2 * rB3;
         rC3_1 += m7;
         m7 = rA3 * rB3;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[26];
         rA1 = pA0[1];
         rA2 = pA0[2];
         rA3 = pA0[3];
         rB1 = pB1[26];
         rB2 = pB2[26];
         rB3 = pB3[26];
         rC0_2 += m0;
         m0 = rA0 * rB0;
         rC1_2 += m1;
         m1 = rA1 * rB0;
         rC2_2 += m2;
         m2 = rA2 * rB0;
         rC3_2 += m3;
         m3 = rA3 * rB0;
         rC0_3 += m4;
         m4 = rA0 * rB1;
         rC1_3 += m5;
         m5 = rA1 * rB1;
         rC2_3 += m6;
         m6 = rA2 * rB1;
         rC3_3 += m7;
         m7 = rA3 * rB1;
         rC0_0 += m0;
         m0 = rA0 * rB2;
         rC1_0 += m1;
         m1 = rA1 * rB2;
         rC2_0 += m2;
         m2 = rA2 * rB2;
         rC3_0 += m3;
         m3 = rA3 * rB2;
         rC0_1 += m4;
         m4 = rA0 * rB3;
         rC1_1 += m5;
         m5 = rA1 * rB3;
         rC2_1 += m6;
         m6 = rA2 * rB3;
         rC3_1 += m7;
         m7 = rA3 * rB3;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[27];
         rA1 = pA0[1];
         rA2 = pA0[2];
         rA3 = pA0[3];
         rB1 = pB1[27];
         rB2 = pB2[27];
         rB3 = pB3[27];
         rC0_2 += m0;
         m0 = rA0 * rB0;
         rC1_2 += m1;
         m1 = rA1 * rB0;
         rC2_2 += m2;
         m2 = rA2 * rB0;
         rC3_2 += m3;
         m3 = rA3 * rB0;
         rC0_3 += m4;
         m4 = rA0 * rB1;
         rC1_3 += m5;
         m5 = rA1 * rB1;
         rC2_3 += m6;
         m6 = rA2 * rB1;
         rC3_3 += m7;
         m7 = rA3 * rB1;
         rC0_0 += m0;
         m0 = rA0 * rB2;
         rC1_0 += m1;
         m1 = rA1 * rB2;
         rC2_0 += m2;
         m2 = rA2 * rB2;
         rC3_0 += m3;
         m3 = rA3 * rB2;
         rC0_1 += m4;
         m4 = rA0 * rB3;
         rC1_1 += m5;
         m5 = rA1 * rB3;
         rC2_1 += m6;
         m6 = rA2 * rB3;
         rC3_1 += m7;
         m7 = rA3 * rB3;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[28];
         rA1 = pA0[1];
         rA2 = pA0[2];
         rA3 = pA0[3];
         rB1 = pB1[28];
         rB2 = pB2[28];
         rB3 = pB3[28];
         rC0_2 += m0;
         m0 = rA0 * rB0;
         rC1_2 += m1;
         m1 = rA1 * rB0;
         rC2_2 += m2;
         m2 = rA2 * rB0;
         rC3_2 += m3;
         m3 = rA3 * rB0;
         rC0_3 += m4;
         m4 = rA0 * rB1;
         rC1_3 += m5;
         m5 = rA1 * rB1;
         rC2_3 += m6;
         m6 = rA2 * rB1;
         rC3_3 += m7;
         m7 = rA3 * rB1;
         rC0_0 += m0;
         m0 = rA0 * rB2;
         rC1_0 += m1;
         m1 = rA1 * rB2;
         rC2_0 += m2;
         m2 = rA2 * rB2;
         rC3_0 += m3;
         m3 = rA3 * rB2;
         rC0_1 += m4;
         m4 = rA0 * rB3;
         rC1_1 += m5;
         m5 = rA1 * rB3;
         rC2_1 += m6;
         m6 = rA2 * rB3;
         rC3_1 += m7;
         m7 = rA3 * rB3;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[29];
         rA1 = pA0[1];
         rA2 = pA0[2];
         rA3 = pA0[3];
         rB1 = pB1[29];
         rB2 = pB2[29];
         rB3 = pB3[29];
         rC0_2 += m0;
         m0 = rA0 * rB0;
         rC1_2 += m1;
         m1 = rA1 * rB0;
         rC2_2 += m2;
         m2 = rA2 * rB0;
         rC3_2 += m3;
         m3 = rA3 * rB0;
         rC0_3 += m4;
         m4 = rA0 * rB1;
         rC1_3 += m5;
         m5 = rA1 * rB1;
         rC2_3 += m6;
         m6 = rA2 * rB1;
         rC3_3 += m7;
         m7 = rA3 * rB1;
         rC0_0 += m0;
         m0 = rA0 * rB2;
         rC1_0 += m1;
         m1 = rA1 * rB2;
         rC2_0 += m2;
         m2 = rA2 * rB2;
         rC3_0 += m3;
         m3 = rA3 * rB2;
         rC0_1 += m4;
         m4 = rA0 * rB3;
         rC1_1 += m5;
         m5 = rA1 * rB3;
         rC2_1 += m6;
         m6 = rA2 * rB3;
         rC3_1 += m7;
         m7 = rA3 * rB3;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[30];
         rA1 = pA0[1];
         rA2 = pA0[2];
         rA3 = pA0[3];
         rB1 = pB1[30];
         rB2 = pB2[30];
         rB3 = pB3[30];
         rC0_2 += m0;
         m0 = rA0 * rB0;
         rC1_2 += m1;
         m1 = rA1 * rB0;
         rC2_2 += m2;
         m2 = rA2 * rB0;
         rC3_2 += m3;
         m3 = rA3 * rB0;
         rC0_3 += m4;
         m4 = rA0 * rB1;
         rC1_3 += m5;
         m5 = rA1 * rB1;
         rC2_3 += m6;
         m6 = rA2 * rB1;
         rC3_3 += m7;
         m7 = rA3 * rB1;
         rC0_0 += m0;
         m0 = rA0 * rB2;
         rC1_0 += m1;
         m1 = rA1 * rB2;
         rC2_0 += m2;
         m2 = rA2 * rB2;
         rC3_0 += m3;
         m3 = rA3 * rB2;
         rC0_1 += m4;
         m4 = rA0 * rB3;
         rC1_1 += m5;
         m5 = rA1 * rB3;
         rC2_1 += m6;
         m6 = rA2 * rB3;
         rC3_1 += m7;
         m7 = rA3 * rB3;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[31];
         rA1 = pA0[1];
         rA2 = pA0[2];
         rA3 = pA0[3];
         rB1 = pB1[31];
         rB2 = pB2[31];
         rB3 = pB3[31];
         rC0_2 += m0;
         m0 = rA0 * rB0;
         rC1_2 += m1;
         m1 = rA1 * rB0;
         rC2_2 += m2;
         m2 = rA2 * rB0;
         rC3_2 += m3;
         m3 = rA3 * rB0;
         rC0_3 += m4;
         m4 = rA0 * rB1;
         rC1_3 += m5;
         m5 = rA1 * rB1;
         rC2_3 += m6;
         m6 = rA2 * rB1;
         rC3_3 += m7;
         m7 = rA3 * rB1;
         rC0_0 += m0;
         m0 = rA0 * rB2;
         rC1_0 += m1;
         m1 = rA1 * rB2;
         rC2_0 += m2;
         m2 = rA2 * rB2;
         rC3_0 += m3;
         m3 = rA3 * rB2;
         rC0_1 += m4;
         m4 = rA0 * rB3;
         rC1_1 += m5;
         m5 = rA1 * rB3;
         rC2_1 += m6;
         m6 = rA2 * rB3;
         rC3_1 += m7;
         m7 = rA3 * rB3;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[32];
         rA1 = pA0[1];
         rA2 = pA0[2];
         rA3 = pA0[3];
         rB1 = pB1[32];
         rB2 = pB2[32];
         rB3 = pB3[32];
         rC0_2 += m0;
         m0 = rA0 * rB0;
         rC1_2 += m1;
         m1 = rA1 * rB0;
         rC2_2 += m2;
         m2 = rA2 * rB0;
         rC3_2 += m3;
         m3 = rA3 * rB0;
         rC0_3 += m4;
         m4 = rA0 * rB1;
         rC1_3 += m5;
         m5 = rA1 * rB1;
         rC2_3 += m6;
         m6 = rA2 * rB1;
         rC3_3 += m7;
         m7 = rA3 * rB1;
         rC0_0 += m0;
         m0 = rA0 * rB2;
         rC1_0 += m1;
         m1 = rA1 * rB2;
         rC2_0 += m2;
         m2 = rA2 * rB2;
         rC3_0 += m3;
         m3 = rA3 * rB2;
         rC0_1 += m4;
         m4 = rA0 * rB3;
         rC1_1 += m5;
         m5 = rA1 * rB3;
         rC2_1 += m6;
         m6 = rA2 * rB3;
         rC3_1 += m7;
         m7 = rA3 * rB3;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[33];
         rA1 = pA0[1];
         rA2 = pA0[2];
         rA3 = pA0[3];
         rB1 = pB1[33];
         rB2 = pB2[33];
         rB3 = pB3[33];
         rC0_2 += m0;
         m0 = rA0 * rB0;
         rC1_2 += m1;
         m1 = rA1 * rB0;
         rC2_2 += m2;
         m2 = rA2 * rB0;
         rC3_2 += m3;
         m3 = rA3 * rB0;
         rC0_3 += m4;
         m4 = rA0 * rB1;
         rC1_3 += m5;
         m5 = rA1 * rB1;
         rC2_3 += m6;
         m6 = rA2 * rB1;
         rC3_3 += m7;
         m7 = rA3 * rB1;
         rC0_0 += m0;
         m0 = rA0 * rB2;
         rC1_0 += m1;
         m1 = rA1 * rB2;
         rC2_0 += m2;
         m2 = rA2 * rB2;
         rC3_0 += m3;
         m3 = rA3 * rB2;
         rC0_1 += m4;
         m4 = rA0 * rB3;
         rC1_1 += m5;
         m5 = rA1 * rB3;
         rC2_1 += m6;
         m6 = rA2 * rB3;
         rC3_1 += m7;
         m7 = rA3 * rB3;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[34];
         rA1 = pA0[1];
         rA2 = pA0[2];
         rA3 = pA0[3];
         rB1 = pB1[34];
         rB2 = pB2[34];
         rB3 = pB3[34];
         rC0_2 += m0;
         m0 = rA0 * rB0;
         rC1_2 += m1;
         m1 = rA1 * rB0;
         rC2_2 += m2;
         m2 = rA2 * rB0;
         rC3_2 += m3;
         m3 = rA3 * rB0;
         rC0_3 += m4;
         m4 = rA0 * rB1;
         rC1_3 += m5;
         m5 = rA1 * rB1;
         rC2_3 += m6;
         m6 = rA2 * rB1;
         rC3_3 += m7;
         m7 = rA3 * rB1;
         rC0_0 += m0;
         m0 = rA0 * rB2;
         rC1_0 += m1;
         m1 = rA1 * rB2;
         rC2_0 += m2;
         m2 = rA2 * rB2;
         rC3_0 += m3;
         m3 = rA3 * rB2;
         rC0_1 += m4;
         m4 = rA0 * rB3;
         rC1_1 += m5;
         m5 = rA1 * rB3;
         rC2_1 += m6;
         m6 = rA2 * rB3;
         rC3_1 += m7;
         m7 = rA3 * rB3;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[35];
         rA1 = pA0[1];
         rA2 = pA0[2];
         rA3 = pA0[3];
         rB1 = pB1[35];
         rB2 = pB2[35];
         rB3 = pB3[35];
         rC0_2 += m0;
         m0 = rA0 * rB0;
         rC1_2 += m1;
         m1 = rA1 * rB0;
         rC2_2 += m2;
         m2 = rA2 * rB0;
         rC3_2 += m3;
         m3 = rA3 * rB0;
         rC0_3 += m4;
         m4 = rA0 * rB1;
         rC1_3 += m5;
         m5 = rA1 * rB1;
         rC2_3 += m6;
         m6 = rA2 * rB1;
         rC3_3 += m7;
         m7 = rA3 * rB1;
         rC0_0 += m0;
         m0 = rA0 * rB2;
         rC1_0 += m1;
         m1 = rA1 * rB2;
         rC2_0 += m2;
         m2 = rA2 * rB2;
         rC3_0 += m3;
         m3 = rA3 * rB2;
         rC0_1 += m4;
         m4 = rA0 * rB3;
         rC1_1 += m5;
         m5 = rA1 * rB3;
         rC2_1 += m6;
         m6 = rA2 * rB3;
         rC3_1 += m7;
         m7 = rA3 * rB3;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[36];
         rA1 = pA0[1];
         rA2 = pA0[2];
         rA3 = pA0[3];
         rB1 = pB1[36];
         rB2 = pB2[36];
         rB3 = pB3[36];
         rC0_2 += m0;
         m0 = rA0 * rB0;
         rC1_2 += m1;
         m1 = rA1 * rB0;
         rC2_2 += m2;
         m2 = rA2 * rB0;
         rC3_2 += m3;
         m3 = rA3 * rB0;
         rC0_3 += m4;
         m4 = rA0 * rB1;
         rC1_3 += m5;
         m5 = rA1 * rB1;
         rC2_3 += m6;
         m6 = rA2 * rB1;
         rC3_3 += m7;
         m7 = rA3 * rB1;
         rC0_0 += m0;
         m0 = rA0 * rB2;
         rC1_0 += m1;
         m1 = rA1 * rB2;
         rC2_0 += m2;
         m2 = rA2 * rB2;
         rC3_0 += m3;
         m3 = rA3 * rB2;
         rC0_1 += m4;
         m4 = rA0 * rB3;
         rC1_1 += m5;
         m5 = rA1 * rB3;
         rC2_1 += m6;
         m6 = rA2 * rB3;
         rC3_1 += m7;
         m7 = rA3 * rB3;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[37];
         rA1 = pA0[1];
         rA2 = pA0[2];
         rA3 = pA0[3];
         rB1 = pB1[37];
         rB2 = pB2[37];
         rB3 = pB3[37];
         rC0_2 += m0;
         m0 = rA0 * rB0;
         rC1_2 += m1;
         m1 = rA1 * rB0;
         rC2_2 += m2;
         m2 = rA2 * rB0;
         rC3_2 += m3;
         m3 = rA3 * rB0;
         rC0_3 += m4;
         m4 = rA0 * rB1;
         rC1_3 += m5;
         m5 = rA1 * rB1;
         rC2_3 += m6;
         m6 = rA2 * rB1;
         rC3_3 += m7;
         m7 = rA3 * rB1;
         rC0_0 += m0;
         m0 = rA0 * rB2;
         rC1_0 += m1;
         m1 = rA1 * rB2;
         rC2_0 += m2;
         m2 = rA2 * rB2;
         rC3_0 += m3;
         m3 = rA3 * rB2;
         rC0_1 += m4;
         m4 = rA0 * rB3;
         rC1_1 += m5;
         m5 = rA1 * rB3;
         rC2_1 += m6;
         m6 = rA2 * rB3;
         rC3_1 += m7;
         m7 = rA3 * rB3;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[38];
         rA1 = pA0[1];
         rA2 = pA0[2];
         rA3 = pA0[3];
         rB1 = pB1[38];
         rB2 = pB2[38];
         rB3 = pB3[38];
         rC0_2 += m0;
         m0 = rA0 * rB0;
         rC1_2 += m1;
         m1 = rA1 * rB0;
         rC2_2 += m2;
         m2 = rA2 * rB0;
         rC3_2 += m3;
         m3 = rA3 * rB0;
         rC0_3 += m4;
         m4 = rA0 * rB1;
         rC1_3 += m5;
         m5 = rA1 * rB1;
         rC2_3 += m6;
         m6 = rA2 * rB1;
         rC3_3 += m7;
         m7 = rA3 * rB1;
         rC0_0 += m0;
         m0 = rA0 * rB2;
         rC1_0 += m1;
         m1 = rA1 * rB2;
         rC2_0 += m2;
         m2 = rA2 * rB2;
         rC3_0 += m3;
         m3 = rA3 * rB2;
         rC0_1 += m4;
         m4 = rA0 * rB3;
         rC1_1 += m5;
         m5 = rA1 * rB3;
         rC2_1 += m6;
         m6 = rA2 * rB3;
         rC3_1 += m7;
         m7 = rA3 * rB3;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[39];
         rA1 = pA0[1];
         rA2 = pA0[2];
         rA3 = pA0[3];
         rB1 = pB1[39];
         rB2 = pB2[39];
         rB3 = pB3[39];
         rC0_2 += m0;
         m0 = rA0 * rB0;
         rC1_2 += m1;
         m1 = rA1 * rB0;
         rC2_2 += m2;
         m2 = rA2 * rB0;
         rC3_2 += m3;
         m3 = rA3 * rB0;
         rC0_3 += m4;
         m4 = rA0 * rB1;
         rC1_3 += m5;
         m5 = rA1 * rB1;
         rC2_3 += m6;
         m6 = rA2 * rB1;
         rC3_3 += m7;
         m7 = rA3 * rB1;
         rC0_0 += m0;
         m0 = rA0 * rB2;
         rC1_0 += m1;
         m1 = rA1 * rB2;
         rC2_0 += m2;
         m2 = rA2 * rB2;
         rC3_0 += m3;
         m3 = rA3 * rB2;
         rC0_1 += m4;
         m4 = rA0 * rB3;
         rC1_1 += m5;
         m5 = rA1 * rB3;
         rC2_1 += m6;
         m6 = rA2 * rB3;
         rC3_1 += m7;
         m7 = rA3 * rB3;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[40];
         rA1 = pA0[1];
         rA2 = pA0[2];
         rA3 = pA0[3];
         rB1 = pB1[40];
         rB2 = pB2[40];
         rB3 = pB3[40];
         rC0_2 += m0;
         m0 = rA0 * rB0;
         rC1_2 += m1;
         m1 = rA1 * rB0;
         rC2_2 += m2;
         m2 = rA2 * rB0;
         rC3_2 += m3;
         m3 = rA3 * rB0;
         rC0_3 += m4;
         m4 = rA0 * rB1;
         rC1_3 += m5;
         m5 = rA1 * rB1;
         rC2_3 += m6;
         m6 = rA2 * rB1;
         rC3_3 += m7;
         m7 = rA3 * rB1;
         rC0_0 += m0;
         m0 = rA0 * rB2;
         rC1_0 += m1;
         m1 = rA1 * rB2;
         rC2_0 += m2;
         m2 = rA2 * rB2;
         rC3_0 += m3;
         m3 = rA3 * rB2;
         rC0_1 += m4;
         m4 = rA0 * rB3;
         rC1_1 += m5;
         m5 = rA1 * rB3;
         rC2_1 += m6;
         m6 = rA2 * rB3;
         rC3_1 += m7;
         m7 = rA3 * rB3;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[41];
         rA1 = pA0[1];
         rA2 = pA0[2];
         rA3 = pA0[3];
         rB1 = pB1[41];
         rB2 = pB2[41];
         rB3 = pB3[41];
         rC0_2 += m0;
         m0 = rA0 * rB0;
         rC1_2 += m1;
         m1 = rA1 * rB0;
         rC2_2 += m2;
         m2 = rA2 * rB0;
         rC3_2 += m3;
         m3 = rA3 * rB0;
         rC0_3 += m4;
         m4 = rA0 * rB1;
         rC1_3 += m5;
         m5 = rA1 * rB1;
         rC2_3 += m6;
         m6 = rA2 * rB1;
         rC3_3 += m7;
         m7 = rA3 * rB1;
         rC0_0 += m0;
         m0 = rA0 * rB2;
         rC1_0 += m1;
         m1 = rA1 * rB2;
         rC2_0 += m2;
         m2 = rA2 * rB2;
         rC3_0 += m3;
         m3 = rA3 * rB2;
         rC0_1 += m4;
         m4 = rA0 * rB3;
         rC1_1 += m5;
         m5 = rA1 * rB3;
         rC2_1 += m6;
         m6 = rA2 * rB3;
         rC3_1 += m7;
         m7 = rA3 * rB3;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[42];
         rA1 = pA0[1];
         rA2 = pA0[2];
         rA3 = pA0[3];
         rB1 = pB1[42];
         rB2 = pB2[42];
         rB3 = pB3[42];
         rC0_2 += m0;
         m0 = rA0 * rB0;
         rC1_2 += m1;
         m1 = rA1 * rB0;
         rC2_2 += m2;
         m2 = rA2 * rB0;
         rC3_2 += m3;
         m3 = rA3 * rB0;
         rC0_3 += m4;
         m4 = rA0 * rB1;
         rC1_3 += m5;
         m5 = rA1 * rB1;
         rC2_3 += m6;
         m6 = rA2 * rB1;
         rC3_3 += m7;
         m7 = rA3 * rB1;
         rC0_0 += m0;
         m0 = rA0 * rB2;
         rC1_0 += m1;
         m1 = rA1 * rB2;
         rC2_0 += m2;
         m2 = rA2 * rB2;
         rC3_0 += m3;
         m3 = rA3 * rB2;
         rC0_1 += m4;
         m4 = rA0 * rB3;
         rC1_1 += m5;
         m5 = rA1 * rB3;
         rC2_1 += m6;
         m6 = rA2 * rB3;
         rC3_1 += m7;
         m7 = rA3 * rB3;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[43];
         rA1 = pA0[1];
         rA2 = pA0[2];
         rA3 = pA0[3];
         rB1 = pB1[43];
         rB2 = pB2[43];
         rB3 = pB3[43];
         rC0_2 += m0;
         m0 = rA0 * rB0;
         rC1_2 += m1;
         m1 = rA1 * rB0;
         rC2_2 += m2;
         m2 = rA2 * rB0;
         rC3_2 += m3;
         m3 = rA3 * rB0;
         rC0_3 += m4;
         m4 = rA0 * rB1;
         rC1_3 += m5;
         m5 = rA1 * rB1;
         rC2_3 += m6;
         m6 = rA2 * rB1;
         rC3_3 += m7;
         m7 = rA3 * rB1;
         rC0_0 += m0;
         m0 = rA0 * rB2;
         rC1_0 += m1;
         m1 = rA1 * rB2;
         rC2_0 += m2;
         m2 = rA2 * rB2;
         rC3_0 += m3;
         m3 = rA3 * rB2;
         rC0_1 += m4;
         m4 = rA0 * rB3;
         rC1_1 += m5;
         m5 = rA1 * rB3;
         rC2_1 += m6;
         m6 = rA2 * rB3;
         rC3_1 += m7;
         m7 = rA3 * rB3;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[44];
         rA1 = pA0[1];
         rA2 = pA0[2];
         rA3 = pA0[3];
         rB1 = pB1[44];
         rB2 = pB2[44];
         rB3 = pB3[44];
         rC0_2 += m0;
         m0 = rA0 * rB0;
         rC1_2 += m1;
         m1 = rA1 * rB0;
         rC2_2 += m2;
         m2 = rA2 * rB0;
         rC3_2 += m3;
         m3 = rA3 * rB0;
         rC0_3 += m4;
         m4 = rA0 * rB1;
         rC1_3 += m5;
         m5 = rA1 * rB1;
         rC2_3 += m6;
         m6 = rA2 * rB1;
         rC3_3 += m7;
         m7 = rA3 * rB1;
         rC0_0 += m0;
         m0 = rA0 * rB2;
         rC1_0 += m1;
         m1 = rA1 * rB2;
         rC2_0 += m2;
         m2 = rA2 * rB2;
         rC3_0 += m3;
         m3 = rA3 * rB2;
         rC0_1 += m4;
         m4 = rA0 * rB3;
         rC1_1 += m5;
         m5 = rA1 * rB3;
         rC2_1 += m6;
         m6 = rA2 * rB3;
         rC3_1 += m7;
         m7 = rA3 * rB3;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[45];
         rA1 = pA0[1];
         rA2 = pA0[2];
         rA3 = pA0[3];
         rB1 = pB1[45];
         rB2 = pB2[45];
         rB3 = pB3[45];
         rC0_2 += m0;
         m0 = rA0 * rB0;
         rC1_2 += m1;
         m1 = rA1 * rB0;
         rC2_2 += m2;
         m2 = rA2 * rB0;
         rC3_2 += m3;
         m3 = rA3 * rB0;
         rC0_3 += m4;
         m4 = rA0 * rB1;
         rC1_3 += m5;
         m5 = rA1 * rB1;
         rC2_3 += m6;
         m6 = rA2 * rB1;
         rC3_3 += m7;
         m7 = rA3 * rB1;
         rC0_0 += m0;
         m0 = rA0 * rB2;
         rC1_0 += m1;
         m1 = rA1 * rB2;
         rC2_0 += m2;
         m2 = rA2 * rB2;
         rC3_0 += m3;
         m3 = rA3 * rB2;
         rC0_1 += m4;
         m4 = rA0 * rB3;
         rC1_1 += m5;
         m5 = rA1 * rB3;
         rC2_1 += m6;
         m6 = rA2 * rB3;
         rC3_1 += m7;
         m7 = rA3 * rB3;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[46];
         rA1 = pA0[1];
         rA2 = pA0[2];
         rA3 = pA0[3];
         rB1 = pB1[46];
         rB2 = pB2[46];
         rB3 = pB3[46];
         rC0_2 += m0;
         m0 = rA0 * rB0;
         rC1_2 += m1;
         m1 = rA1 * rB0;
         rC2_2 += m2;
         m2 = rA2 * rB0;
         rC3_2 += m3;
         m3 = rA3 * rB0;
         rC0_3 += m4;
         m4 = rA0 * rB1;
         rC1_3 += m5;
         m5 = rA1 * rB1;
         rC2_3 += m6;
         m6 = rA2 * rB1;
         rC3_3 += m7;
         m7 = rA3 * rB1;
         rC0_0 += m0;
         m0 = rA0 * rB2;
         rC1_0 += m1;
         m1 = rA1 * rB2;
         rC2_0 += m2;
         m2 = rA2 * rB2;
         rC3_0 += m3;
         m3 = rA3 * rB2;
         rC0_1 += m4;
         m4 = rA0 * rB3;
         rC1_1 += m5;
         m5 = rA1 * rB3;
         rC2_1 += m6;
         m6 = rA2 * rB3;
         rC3_1 += m7;
         m7 = rA3 * rB3;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[47];
         rA1 = pA0[1];
         rA2 = pA0[2];
         rA3 = pA0[3];
         rB1 = pB1[47];
         rB2 = pB2[47];
         rB3 = pB3[47];
         rC0_2 += m0;
         m0 = rA0 * rB0;
         rC1_2 += m1;
         m1 = rA1 * rB0;
         rC2_2 += m2;
         m2 = rA2 * rB0;
         rC3_2 += m3;
         m3 = rA3 * rB0;
         rC0_3 += m4;
         m4 = rA0 * rB1;
         rC1_3 += m5;
         m5 = rA1 * rB1;
         rC2_3 += m6;
         m6 = rA2 * rB1;
         rC3_3 += m7;
         m7 = rA3 * rB1;
         rC0_0 += m0;
         m0 = rA0 * rB2;
         rC1_0 += m1;
         m1 = rA1 * rB2;
         rC2_0 += m2;
         m2 = rA2 * rB2;
         rC3_0 += m3;
         m3 = rA3 * rB2;
         rC0_1 += m4;
         m4 = rA0 * rB3;
         rC1_1 += m5;
         m5 = rA1 * rB3;
         rC2_1 += m6;
         m6 = rA2 * rB3;
         rC3_1 += m7;
         m7 = rA3 * rB3;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[48];
         rA1 = pA0[1];
         rA2 = pA0[2];
         rA3 = pA0[3];
         rB1 = pB1[48];
         rB2 = pB2[48];
         rB3 = pB3[48];
         rC0_2 += m0;
         m0 = rA0 * rB0;
         rC1_2 += m1;
         m1 = rA1 * rB0;
         rC2_2 += m2;
         m2 = rA2 * rB0;
         rC3_2 += m3;
         m3 = rA3 * rB0;
         rC0_3 += m4;
         m4 = rA0 * rB1;
         rC1_3 += m5;
         m5 = rA1 * rB1;
         rC2_3 += m6;
         m6 = rA2 * rB1;
         rC3_3 += m7;
         m7 = rA3 * rB1;
         rC0_0 += m0;
         m0 = rA0 * rB2;
         rC1_0 += m1;
         m1 = rA1 * rB2;
         rC2_0 += m2;
         m2 = rA2 * rB2;
         rC3_0 += m3;
         m3 = rA3 * rB2;
         rC0_1 += m4;
         m4 = rA0 * rB3;
         rC1_1 += m5;
         m5 = rA1 * rB3;
         rC2_1 += m6;
         m6 = rA2 * rB3;
         rC3_1 += m7;
         m7 = rA3 * rB3;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[49];
         rA1 = pA0[1];
         rA2 = pA0[2];
         rA3 = pA0[3];
         rB1 = pB1[49];
         rB2 = pB2[49];
         rB3 = pB3[49];
         rC0_2 += m0;
         m0 = rA0 * rB0;
         rC1_2 += m1;
         m1 = rA1 * rB0;
         rC2_2 += m2;
         m2 = rA2 * rB0;
         rC3_2 += m3;
         m3 = rA3 * rB0;
         rC0_3 += m4;
         m4 = rA0 * rB1;
         rC1_3 += m5;
         m5 = rA1 * rB1;
         rC2_3 += m6;
         m6 = rA2 * rB1;
         rC3_3 += m7;
         m7 = rA3 * rB1;
         rC0_0 += m0;
         m0 = rA0 * rB2;
         rC1_0 += m1;
         m1 = rA1 * rB2;
         rC2_0 += m2;
         m2 = rA2 * rB2;
         rC3_0 += m3;
         m3 = rA3 * rB2;
         rC0_1 += m4;
         m4 = rA0 * rB3;
         rC1_1 += m5;
         m5 = rA1 * rB3;
         rC2_1 += m6;
         m6 = rA2 * rB3;
         rC3_1 += m7;
         m7 = rA3 * rB3;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[50];
         rA1 = pA0[1];
         rA2 = pA0[2];
         rA3 = pA0[3];
         rB1 = pB1[50];
         rB2 = pB2[50];
         rB3 = pB3[50];
         rC0_2 += m0;
         m0 = rA0 * rB0;
         rC1_2 += m1;
         m1 = rA1 * rB0;
         rC2_2 += m2;
         m2 = rA2 * rB0;
         rC3_2 += m3;
         m3 = rA3 * rB0;
         rC0_3 += m4;
         m4 = rA0 * rB1;
         rC1_3 += m5;
         m5 = rA1 * rB1;
         rC2_3 += m6;
         m6 = rA2 * rB1;
         rC3_3 += m7;
         m7 = rA3 * rB1;
         rC0_0 += m0;
         m0 = rA0 * rB2;
         rC1_0 += m1;
         m1 = rA1 * rB2;
         rC2_0 += m2;
         m2 = rA2 * rB2;
         rC3_0 += m3;
         m3 = rA3 * rB2;
         rC0_1 += m4;
         m4 = rA0 * rB3;
         rC1_1 += m5;
         m5 = rA1 * rB3;
         rC2_1 += m6;
         m6 = rA2 * rB3;
         rC3_1 += m7;
         m7 = rA3 * rB3;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[51];
         rA1 = pA0[1];
         rA2 = pA0[2];
         rA3 = pA0[3];
         rB1 = pB1[51];
         rB2 = pB2[51];
         rB3 = pB3[51];
         rC0_2 += m0;
         m0 = rA0 * rB0;
         rC1_2 += m1;
         m1 = rA1 * rB0;
         rC2_2 += m2;
         m2 = rA2 * rB0;
         rC3_2 += m3;
         m3 = rA3 * rB0;
         rC0_3 += m4;
         m4 = rA0 * rB1;
         rC1_3 += m5;
         m5 = rA1 * rB1;
         rC2_3 += m6;
         m6 = rA2 * rB1;
         rC3_3 += m7;
         m7 = rA3 * rB1;
         rC0_0 += m0;
         m0 = rA0 * rB2;
         rC1_0 += m1;
         m1 = rA1 * rB2;
         rC2_0 += m2;
         m2 = rA2 * rB2;
         rC3_0 += m3;
         m3 = rA3 * rB2;
         rC0_1 += m4;
         m4 = rA0 * rB3;
         rC1_1 += m5;
         m5 = rA1 * rB3;
         rC2_1 += m6;
         m6 = rA2 * rB3;
         rC3_1 += m7;
         m7 = rA3 * rB3;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[52];
         rA1 = pA0[1];
         rA2 = pA0[2];
         rA3 = pA0[3];
         rB1 = pB1[52];
         rB2 = pB2[52];
         rB3 = pB3[52];
         rC0_2 += m0;
         m0 = rA0 * rB0;
         rC1_2 += m1;
         m1 = rA1 * rB0;
         rC2_2 += m2;
         m2 = rA2 * rB0;
         rC3_2 += m3;
         m3 = rA3 * rB0;
         rC0_3 += m4;
         m4 = rA0 * rB1;
         rC1_3 += m5;
         m5 = rA1 * rB1;
         rC2_3 += m6;
         m6 = rA2 * rB1;
         rC3_3 += m7;
         m7 = rA3 * rB1;
         rC0_0 += m0;
         m0 = rA0 * rB2;
         rC1_0 += m1;
         m1 = rA1 * rB2;
         rC2_0 += m2;
         m2 = rA2 * rB2;
         rC3_0 += m3;
         m3 = rA3 * rB2;
         rC0_1 += m4;
         m4 = rA0 * rB3;
         rC1_1 += m5;
         m5 = rA1 * rB3;
         rC2_1 += m6;
         m6 = rA2 * rB3;
         rC3_1 += m7;
         m7 = rA3 * rB3;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[53];
         rA1 = pA0[1];
         rA2 = pA0[2];
         rA3 = pA0[3];
         rB1 = pB1[53];
         rB2 = pB2[53];
         rB3 = pB3[53];
         rC0_2 += m0;
         m0 = rA0 * rB0;
         rC1_2 += m1;
         m1 = rA1 * rB0;
         rC2_2 += m2;
         m2 = rA2 * rB0;
         rC3_2 += m3;
         m3 = rA3 * rB0;
         rC0_3 += m4;
         m4 = rA0 * rB1;
         rC1_3 += m5;
         m5 = rA1 * rB1;
         rC2_3 += m6;
         m6 = rA2 * rB1;
         rC3_3 += m7;
         m7 = rA3 * rB1;
         rC0_0 += m0;
         m0 = rA0 * rB2;
         rC1_0 += m1;
         m1 = rA1 * rB2;
         rC2_0 += m2;
         m2 = rA2 * rB2;
         rC3_0 += m3;
         m3 = rA3 * rB2;
         rC0_1 += m4;
         m4 = rA0 * rB3;
         rC1_1 += m5;
         m5 = rA1 * rB3;
         rC2_1 += m6;
         m6 = rA2 * rB3;
         rC3_1 += m7;
         m7 = rA3 * rB3;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[54];
         rA1 = pA0[1];
         rA2 = pA0[2];
         rA3 = pA0[3];
         rB1 = pB1[54];
         rB2 = pB2[54];
         rB3 = pB3[54];
         rC0_2 += m0;
         m0 = rA0 * rB0;
         rC1_2 += m1;
         m1 = rA1 * rB0;
         rC2_2 += m2;
         m2 = rA2 * rB0;
         rC3_2 += m3;
         m3 = rA3 * rB0;
         rC0_3 += m4;
         m4 = rA0 * rB1;
         rC1_3 += m5;
         m5 = rA1 * rB1;
         rC2_3 += m6;
         m6 = rA2 * rB1;
         rC3_3 += m7;
         m7 = rA3 * rB1;
         rC0_0 += m0;
         m0 = rA0 * rB2;
         rC1_0 += m1;
         m1 = rA1 * rB2;
         rC2_0 += m2;
         m2 = rA2 * rB2;
         rC3_0 += m3;
         m3 = rA3 * rB2;
         rC0_1 += m4;
         m4 = rA0 * rB3;
         rC1_1 += m5;
         m5 = rA1 * rB3;
         rC2_1 += m6;
         m6 = rA2 * rB3;
         rC3_1 += m7;
         m7 = rA3 * rB3;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[55];
         rA1 = pA0[1];
         rA2 = pA0[2];
         rA3 = pA0[3];
         rB1 = pB1[55];
         rB2 = pB2[55];
         rB3 = pB3[55];
         rC0_2 += m0;
         m0 = rA0 * rB0;
         rC1_2 += m1;
         m1 = rA1 * rB0;
         rC2_2 += m2;
         m2 = rA2 * rB0;
         rC3_2 += m3;
         m3 = rA3 * rB0;
         rC0_3 += m4;
         m4 = rA0 * rB1;
         rC1_3 += m5;
         m5 = rA1 * rB1;
         rC2_3 += m6;
         m6 = rA2 * rB1;
         rC3_3 += m7;
         m7 = rA3 * rB1;
/*
 *       Drain pipe on last iteration of K-loop
 */
         rC0_0 += m0;
         m0 = rA0 * rB2;
         rC1_0 += m1;
         m1 = rA1 * rB2;
         rC2_0 += m2;
         m2 = rA2 * rB2;
         rC3_0 += m3;
         m3 = rA3 * rB2;
         rC0_1 += m4;
         m4 = rA0 * rB3;
         rC1_1 += m5;
         m5 = rA1 * rB3;
         rC2_1 += m6;
         m6 = rA2 * rB3;
         rC3_1 += m7;
         m7 = rA3 * rB3;
         pA0 += incAk;
         rC0_2 += m0;
         rC1_2 += m1;
         rC2_2 += m2;
         rC3_2 += m3;
         rC0_3 += m4;
         rC1_3 += m5;
         rC2_3 += m6;
         rC3_3 += m7;
         pB0 += incBk;
         pB1 += incBk;
         pB2 += incBk;
         pB3 += incBk;
         *pC0 = rC0_0;
         pC0[1] = rC1_0;
         pC0[2] = rC2_0;
         pC0[3] = rC3_0;
         *pC1 = rC0_1;
         pC1[1] = rC1_1;
         pC1[2] = rC2_1;
         pC1[3] = rC3_1;
         *pC2 = rC0_2;
         pC2[1] = rC1_2;
         pC2[2] = rC2_2;
         pC2[3] = rC3_2;
         *pC3 = rC0_3;
         pC3[1] = rC1_3;
         pC3[2] = rC2_3;
         pC3[3] = rC3_3;
         pC0 += incCm;
         pC1 += incCm;
         pC2 += incCm;
         pC3 += incCm;
         pA0 += incAm;
         pB0 += incBm;
         pB1 += incBm;
         pB2 += incBm;
         pB3 += incBm;
      }
      while(pA0 != stM);
      pC0 += incCn;
      pC1 += incCn;
      pC2 += incCn;
      pC3 += incCn;
      pA0 += incAn;
      pB0 += incBn;
      pB1 += incBn;
      pB2 += incBn;
      pB3 += incBn;
   }
   while(pB0 != stN);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
